package com.sun.org.apache.bcel.internal.generic;

import com.sun.org.apache.bcel.internal.classfile.ElementValue;
import java.io.IOException;
import java.io.DataOutputStream;
import com.sun.org.apache.bcel.internal.classfile.AnnotationElementValue;

public class AnnotationElementValueGen extends ElementValueGen
{
    private final AnnotationEntryGen a;
    
    public AnnotationElementValueGen(AnnotationEntryGen a, ConstantPoolGen cpool) {
        super(64, cpool);
        this.a = a;
    }
    
    public AnnotationElementValueGen(int type, AnnotationEntryGen annotation, ConstantPoolGen cpool) {
        super(type, cpool);
        if (type != 64) {
            throw new RuntimeException("Only element values of type annotation can be built with this ctor - type specified: " + type);
        }
        this.a = annotation;
        return;
    }
    
    public AnnotationElementValueGen(AnnotationElementValue value, ConstantPoolGen cpool, boolean copyPoolEntries) {
        super(64, cpool);
        this.a = new AnnotationEntryGen(value.getAnnotationEntry(), cpool, copyPoolEntries);
    }
    
    @Override
    public void dump(DataOutputStream dos) throws IOException {
        dos.writeByte(super.getElementValueType());
        this.a.dump(dos);
    }
    
    @Override
    public String stringifyValue() {
        throw new RuntimeException("Not implemented yet");
    }
    
    @Override
    public ElementValue getElementValue() {
        return new AnnotationElementValue(super.getElementValueType(), this.a.getAnnotation(), this.getConstantPool().getConstantPool());
    }
    
    public AnnotationEntryGen getAnnotation() {
        return this.a;
    }
}
